#ifndef FZ_AUTHENTICATION_ERROR_HPP
#define FZ_AUTHENTICATION_ERROR_HPP

#include <cstdint>

namespace fz::authentication
{

struct error
{
	enum type: std::uint8_t {
		none,
		user_disabled,
		user_nonexisting,
		ip_disallowed,
		auth_method_not_supported,
		invalid_credentials,
		internal
	};

	error(type v = none)
		: v_(v)
	{}

	explicit operator bool() const noexcept
	{
		return v_ != none;
	}

	operator type() const noexcept
	{
		return v_;
	}

private:
	type v_;
};

}


#endif // FZ_AUTHENTICATION_ERROR_HPP
