#include "flavour.hpp"
#include "util/parser.hpp"

namespace fz {

bool convert(std::string_view s, flavour &f)
{
	f = {};

	// First check if the string is in a valid format: must be a C-like identifier.
	if (util::parseable_range r(s); !(lit(r, 'a', 'z') || lit(r, 'A', 'Z') || lit(r, '_')))
		return false;
	else
	while (!eol(r)) {
		if (!(lit(r, 'a', 'z') || lit(r, 'A', 'Z') || lit(r, '_') || lit(r, '0', '9')))
			return false;
	}

	if (s == "standard")
		f = flavour::standard;
	else
	if (s == "professional_enterprise")
		f = flavour::professional_enterprise;

	return true;
}


}
