#ifndef FZ_FLAVOUR_HPP
#define FZ_FLAVOUR_HPP

#include <cstdint>
#include <string_view>

#ifndef FZ_FLAVOUR
#	define FZ_FLAVOUR standard
#endif

namespace fz {

enum class flavour: std::uint8_t {
	standard                = 1,
	professional_enterprise = 2
};

inline constexpr auto current_flavour = flavour::FZ_FLAVOUR;

//! Converts string to flavour
bool convert(std::string_view s, flavour &f);

}


#endif // FZ_FLAVOUR_HPP
