#ifndef FZ_HTTP_REQUEST_HPP
#define FZ_HTTP_REQUEST_HPP

#include <string>
#include <libfilezilla/uri.hpp>

#include "headers.hpp"

namespace fz::http
{

class request
{
public:
	std::string method;
	fz::uri uri;
	std::string body;
	http::headers headers;

public:
	inline static const std::string GET    { "GET" };
	inline static const std::string POST   { "POST" };
	inline static const std::string PUT    { "PUT" };
	inline static const std::string HEAD   { "HEAD" };
	inline static const std::string PATCH  { "PATCH" };
	#undef DELETE // Ah, windows...
	inline static const std::string DELETE { "DELETE" };
};

}

#endif // FZ_HTTP_REQUEST_HPP
