#ifndef FZ_SERIALIZATION_TYPES_COMMON_HPP
#define FZ_SERIALIZATION_TYPES_COMMON_HPP

#include <cstdint>
#include <type_traits>
#include <utility>

#include "../../serialization/trait.hpp"

namespace fz::serialization
{
	//! Save enums
	template <typename Archive, typename E, std::enable_if_t<std::is_enum_v<E>>* = nullptr>
	auto save_minimal(const Archive &, const E &e) {
		return std::underlying_type_t<E>(e);
	}

	//! Load enums
	template <typename Archive, typename E, std::enable_if_t<std::is_enum_v<E>>* = nullptr>
	void load_minimal(const Archive &, E &e, const std::underlying_type_t<E> &v) {
		e = static_cast<E>(v);
	}

}

#endif // FZ_SERIALIZATION_TYPES_COMMON_HPP
