#include <libfilezilla/glue/wx.hpp>

#include "gridcellenumrendererex.hpp"
#include <iostream>

void wxGridCellEnumRendererEx::Draw(wxGrid &grid, wxGridCellAttr &attr, wxDC &dc, const wxRect &rectCell, int row, int col, bool isSelected)
{
	wxGridCellRenderer::Draw(grid, attr, dc, rectCell, row, col, isSelected);

	SetTextColoursAndFont(grid, attr, dc, isSelected);

	wxRect rect = rectCell;
	rect.Inflate(-1);

	int halign, valign;
	attr.GetAlignment(&halign, &valign);

	grid.DrawTextRectangle(dc, GetString(grid, row, col), rect, halign, valign);
}

wxSize wxGridCellEnumRendererEx::GetBestSize(wxGrid &, wxGridCellAttr &attr, wxDC &dc, int, int)
{
	wxSize best_size;

	for (auto &c: m_choices) {
		auto cur = DoGetBestSize(attr, dc, c);
		if (best_size.GetWidth() < cur.GetWidth())
			best_size = cur;
	}

	return best_size;
}
